﻿package com {
	
	import flash.display.MovieClip;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	import flash.events.MouseEvent;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import flash.geom.Rectangle;
	
	public class Transformations extends MovieClip {
		
		var stageMc:MovieClip;
		var notesContainer:MovieClip = new MovieClip();
		var reflectionContainer:MovieClip = new MovieClip();
		var reflectionContainer1:MovieClip = new MovieClip();
		var scaTween:Tween;
		var xTween:Tween;
		var objClass:Class;
		var totalNotes = 0;
		var objArr:Array = [41.2, 41.3, 41.3, 41.4, 40.8, 41.5, 41.5, 40.8, 41.6, 40.9, 41.3, 41.2, 41.3, 41.1, 41.4, 43.0, 40.7, 41.5, 41.5, 41.1, 41.4, 41.0, 40.4];
		var objNum = 1;
		var objectsWidth = 0;
		var selectObj:MovieClip
		
		public function Transformations() {
			stageMc = this;
			init();
		}
		
		private function init() {
			stageMc.addChild(reflectionContainer);
			addObjects();
			//notesBtn.buttonMode=true;
			//notesBtn.addEventListener(MouseEvent.CLICK, showNotes);
			
			rightBtn.buttonMode = true;
			rightBtn.addEventListener(MouseEvent.CLICK, rightMov);
			leftBtn.buttonMode = true;
			leftBtn.addEventListener(MouseEvent.CLICK, leftMov);
			reflecBtn.addEventListener(MouseEvent.CLICK, doReflect);
			
			//clrBtn1.gotoAndStop(2);
			for (var i = 1; i <= 4; i++) {
				//colorPalette_mc["clr_" + i].num = i;
				colorPalette_mc["clr_" + i].addEventListener(MouseEvent.CLICK, setColour);
			}
			
			for (var j = 1; j <= 4; j++) {
				movePalette_mc["hi" + j].num = j;
				movePalette_mc["hi" + j].addEventListener(MouseEvent.CLICK, moveObj);
			}
			
			for (var k = 1; k <= 4; k++) {
				rotatePalette_mc["hi" + k].num = k;
				rotatePalette_mc["hi" + k].addEventListener(MouseEvent.CLICK, rotateObj);
			}
			
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
		}
		
		private function addObjects() {
			for (var i = 1; i <= 1; i++) {
				
				var myObject:objectsMc = new objectsMc();
				myObject.name = "objectsMc" + i;
				objectsWidth = myObject.width;
				switch (i) {
					case 1: 
						myObject.x = 0;
						myObject.y = 0;
						break;
					
					case 2: 
						myObject.x = (0 - myObject.width - 14);
						myObject.y = 0;
						break;
					
					case 3: 
						myObject.x = (0 + myObject.width + 14);
						myObject.y = 0;
						break;
				}
				objectContainer.addChild(myObject);
				for (var j = 1; j <= 23; j++) {
					var myObj = myObject.getChildByName("object" + j);
					myObj.num = j;
					myObj.addEventListener(MouseEvent.CLICK, setObject);
				}
			}
		}
		
		private function setObject(evt:MouseEvent) {
			
			clearAll(reflectionContainer);
			objClass = Class(getDefinitionByName(getQualifiedClassName(evt.currentTarget)));
			for (var i = 1; i <= 2; i++) {
				var refObj = new objClass();
				refObj.name = "objMc" + i;
				refObj.x = 385;
				refObj.y = 280;
				refObj.scaleX = 6;
				refObj.scaleY = 6;
				refObj.initX = refObj.x;
				refObj.initY = refObj.y;
				refObj.initScaX = refObj.scaleX;
				refObj.gotoAndStop(evt.currentTarget.currentFrame);
				//refObj.addEventListener(MouseEvent.CLICK,chooseObj);
				reflectionContainer.addChild(refObj);
				reflectionContainer.alpha = 1;
			}
			
			MovieClip(reflectionContainer.getChildByName("objMc1")).alpha = 0.3;
			var selectObj = MovieClip(reflectionContainer.getChildByName("objMc2"));
			selectObj.addEventListener(MouseEvent.MOUSE_DOWN, dragObj);
			selectObj.addEventListener(MouseEvent.MOUSE_UP, dropObj);
		
		}
		
		private function setColour(evt:MouseEvent) {
			for (var i = 1; i <= 4; i++) {
				colorPalette_mc["clr_" + i].visible=true;
			}
			
			var num = evt.currentTarget.name.split("_")[1];
			
			colorPalette_mc["clr_" + num].visible=false;
			var myObject;
			var myObjectMc = objectContainer.getChildByName("objectsMc1");
			for (i = 1; i <= 23; i++) {
				myObject = myObjectMc.getChildByName("object" + i);
				myObject.gotoAndStop(num);
			}
			
			for (i = 1; i <= 2; i++) {
				var tem = MovieClip(reflectionContainer.getChildByName("objMc" + i))
				if (tem)
					tem.gotoAndStop(num);
			}
		}
		
		private function chooseObj(e:MouseEvent):void {
			reflectionContainer.alpha = 0.3;
			
			var refObj = new objClass();
			refObj.width = reflectionContainer.width;
			refObj.height = reflectionContainer.height;
			refObj.x = mouseX;
			refObj.y = mouseY;
			refObj.gotoAndStop(e.currentTarget.currentFrame);
			refObj.addEventListener(MouseEvent.MOUSE_DOWN, dragObj);
			refObj.addEventListener(MouseEvent.MOUSE_UP, dropObj);
			//refObj.addEventListener(MouseEvent.MOUSE_OUT,dropObj);
			//refObj.addEventListener(MouseEvent.MOUSE_MOVE,dropObj);
			addChild(refObj)
			selectObj = refObj;
		
		}
		
		private function rotateObj(e):void {
			MovieClip(reflectionContainer.getChildByName("objMc1")).alpha = 0.3;
			var selectObj = MovieClip(reflectionContainer.getChildByName("objMc" + 2));
			
			if (e.currentTarget.num == 1) {
				selectObj.rotation += 45;
			} else if (e.currentTarget.num == 2) {
				selectObj.rotation += 90;
			} else if (e.currentTarget.num == 3) {
				selectObj.rotation -= 45;
			} else {
				selectObj.rotation -= 90;
			}
		}
		
		private function moveObj(e:MouseEvent):void {
			
			MovieClip(reflectionContainer.getChildByName("objMc1")).alpha = 0.3;
			var selectObj = MovieClip(reflectionContainer.getChildByName("objMc2"));
			
			if (e.currentTarget.num == 1) {
				
				if (!selectObj.hitTestObject(topMc)) {
					selectObj.y -= 15;
				}
			} else if (e.currentTarget.num == 2) {
				
				if (!selectObj.hitTestObject(botMc)) {
					selectObj.y += 15;
				}
			} else if (e.currentTarget.num == 3) {
				
				if (!selectObj.hitTestObject(leftMc)) {
					selectObj.x -= 15;
				}
			} else {
				
				if (!selectObj.hitTestObject(rightMc)) {
					selectObj.x += 15;
				}
			}
		
		}
		var curdragobj;
		private function dragObj(e:MouseEvent):void {
			curdragobj = e.currentTarget;
			stage.addEventListener(MouseEvent.MOUSE_UP, dropObj);
			
			curdragobj.startDrag(false, new Rectangle(120, 90, 540, 300));
		}
		
		private function dropObj(e:MouseEvent):void {
			
			
			
			curdragobj.stopDrag();
			
			if (curdragobj.hitTestObject(leftMc)) {
				curdragobj.x = 140;
			} else if (curdragobj.hitTestObject(rightMc)) {
				curdragobj.x = 625;
			}
			if (curdragobj.hitTestObject(topMc)) {
				curdragobj.y = 115;
			} else if (curdragobj.hitTestObject(botMc)) {
				curdragobj.y = 370;
			} /*else {
				e.currentTarget.x = mouseX - 10;
				e.currentTarget.y = mouseY - 5;
			}*/
			
			
			stage.removeEventListener(MouseEvent.MOUSE_UP, dropObj);
		}
		
		private function doReflect(evt:MouseEvent) {
			MovieClip(reflectionContainer.getChildByName("objMc1")).alpha = 1;
			
			if (reflectionContainer.numChildren >= 1) {
				if (scaTween != null) {
					if (scaTween.isPlaying) {
						scaTween.stop();
						xTween.stop();
					}
				}
				var tweenObj = reflectionContainer.getChildByName("objMc" + 2);
				tweenObj.x = tweenObj.initX;
				tweenObj.y = tweenObj.initY;
				tweenObj.rotation = 0;
				
				tweenObj.scaleX = tweenObj.initScaX;
				scaTween = new Tween(tweenObj, "scaleX", Regular.easeOut, (tweenObj.scaleX), (-tweenObj.scaleX), 0.25, true);
				xTween = new Tween(tweenObj, "x", Regular.easeOut, (tweenObj.x), (tweenObj.x + (tweenObj.width + 20)), 0.25, true);
			}
		}
		
		private function clearAll(cont) {
			while (cont.numChildren) {
				cont.removeChildAt(0);
			}
		}
		
		private function rightMov(evt:MouseEvent) {
			/*for(var i=1; i<=3; i++){
			   var myObject = objectContainer.getChildByName("objectsMc"+i);
			   myObject.x -= 41;
			 }*/
			var myObject;
			var myObject1;
			var myObjectMc = objectContainer.getChildByName("objectsMc1");
			for (var i = 1; i <= 23; i++) {
				myObject = myObjectMc.getChildByName("object" + i);
				myObject.x -= objArr[objNum - 1];
				
			}
			for (i = 1; i <= 23; i++) {
				myObject = myObjectMc.getChildByName("object" + i);
				if (myObject.x < 0) {
					if (i == 1) {
						myObject1 = myObjectMc.getChildByName("object" + 23);
						myObject.x = myObject1.x + (objArr[23 - 1]);
						trace(objArr[23 - 1]);
					} else {
						myObject1 = myObjectMc.getChildByName("object" + (i - 1));
						myObject.x = myObject1.x + (objArr[i - 1]);
					}
				}
			}
			//
			//trace(objArr[objNum-1]);
			objNum++;
			if (objNum > 23) {
				objNum = 1;
			}
		}
		
		private function leftMov(evt:MouseEvent) {
			/*for(var i=1; i<=3; i++){
			   var myObject = objectContainer.getChildByName("objectsMc"+i);
			   myObject.x += objArr[objNum-1];
			 }*/
			var myObject;
			var myObject1;
			var myObjectMc = objectContainer.getChildByName("objectsMc1");
			for (var i = 1; i <= 23; i++) {
				myObject = myObjectMc.getChildByName("object" + i);
				myObject.x += objArr[objNum - 1];
				
			}
			for (i = 1; i <= 23; i++) {
				myObject = myObjectMc.getChildByName("object" + i);
				if (myObject.x > objectsWidth) {
					if (i == 23) {
						myObject1 = myObjectMc.getChildByName("object" + 1);
						myObject.x = myObject1.x - (objArr[1 - 1]);
					} else {
						myObject1 = myObjectMc.getChildByName("object" + (i + 1));
						myObject.x = myObject1.x - (objArr[i - 1]);
					}
				}
			}
			objNum--;
			if (objNum < 1) {
				objNum = 23;
			}
		}
		
		/*private function showNotes(evt:MouseEvent) {
			stageMc.addChildAt(notesContainer, stageMc.numChildren - 1);
			totalNotes++;
			var myNotes:Notes = new Notes(stageMc, totalNotes, notesContainer);
		}*/
		
		private function onReset(evt:MouseEvent) {
			clearAll(reflectionContainer);
			clearAll(notesContainer);
			//stageMc["clrBtn1"].dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			if (selectObj != null)
				removeChild(selectObj);
		}
	
	}
}